#ifndef _pyutil_
#define _pyutil_

#include <string.h>
#include "Python.h"
#include "stock.h"
#include "pf.h"
#include "db.h"

#define squawk(...) { char msg[STRSZ]; sprintf( msg, __VA_ARGS__ ); if( ! strncmp( msg, "Usage:", 6 ) ) { PyErr_SetString( PyExc_TypeError, msg ); } else { PyErr_WarnEx( NULL, msg, 1 ); } }

typedef struct Floatvector {
	float	*data;
	long	nsamp;
} Floatvector;

#ifdef  __cplusplus
extern "C" {
#endif

extern int parse_from_Boolean( PyObject *obj, void *addr );
extern int parse_to_strtbl( PyObject *obj, void *addr );
extern int parse_to_inttbl( PyObject *obj, void *addr );
extern int parse_to_floats( PyObject *obj, void *addr );
extern int parse_to_Dbptr( PyObject *obj, void *addr );
extern int parse_to_Pf( PyObject *obj, void *addr );
extern int parse_to_addr( PyObject *obj, void **addrp );
extern int parse_to_addr_deregister( PyObject *obj, void **addrp );
extern int parse_to_addr_tbl( PyObject *obj, void *atblp );
extern int PyObject2Dbvalue( PyObject *obj, long type, Dbvalue *value );
extern PyObject *Dbptr2PyObject( Dbptr db );
extern PyObject *Dbvalue2PyObject( Dbvalue value, int type );
extern PyObject *strtbl2PyObject( Tbl *atbl );
extern PyObject *strarr2PyObject( Arr *anarr );
extern PyObject *inttbl2PyObject( Tbl *atbl );
extern PyObject *string2PyObject( char *s );
extern PyObject *strtbl2PyObject( Tbl *atbl );
extern PyObject *pf2PyObject( Pf *pfvalue );
extern PyObject *addr2PyObject( void *addr, char *type );
extern Pf *PyObject2pf( PyObject *pyvalue );
extern int pyutil_deregister_handle( char *handle, void *private );
extern int pyutil_deregister_address( void *addr, void *private );
extern char *pyutil_elogmsgs();

#ifdef  __cplusplus
}
#endif

#endif
